//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
	Handle=INVALID_HANDLE_VALUE;
    InitTimeValue();
}
//---------------------------------------------------------------------------
// Serial Interface
//---------------------------------------------------------------------------
bool TForm1::PortOpen(AnsiString PortStr)
{
    ULONG BufSize;
    BOOL retc;
    AnsiString port;
	if(PortStr[1]!='\\')
		port="\\\\.\\"+PortStr;
    else
    	port=PortStr;

	Handle=CreateFile(port.c_str(),
					  GENERIC_READ | GENERIC_WRITE,
					  0,NULL,OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,
					  NULL );
	if(!IsOpen()){
		//Open Error
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
bool TForm1::PortClose()
{
	if(IsOpen()){
		//Buffer Flash
		CloseHandle(Handle);
		Handle=INVALID_HANDLE_VALUE;
	}
	return true;
}
//---------------------------------------------------------------------------
bool TForm1::IsDsrSignal()
{
	DWORD mState;
	GetCommModemStatus(Handle,&mState);
	if(mState & MS_DSR_ON)
		return true;
	return false;
}
//---------------------------------------------------------------------------
bool TForm1::IsCtsSignal()
{
	DWORD mState;
	GetCommModemStatus(Handle,&mState);
	if(mState & MS_CTS_ON)
		return true;
	return false;
}
//---------------------------------------------------------------------------
void TForm1::SetDtrSignal(bool setflg)
{
	if(setflg)
		EscapeCommFunction(Handle,SETDTR);
	else
		EscapeCommFunction(Handle,CLRDTR);
}
//---------------------------------------------------------------------------
void TForm1::SetRtsSignal(bool setflg)
{
	if(setflg)
		EscapeCommFunction(Handle,SETRTS);
	else
		EscapeCommFunction(Handle,CLRRTS);
}
//---------------------------------------------------------------------------
void TForm1::ShowData(int Temp)
{
	//艷x\
    //x́APOO{ꂽl
    int HTemp;	//x̐
    int LTemp;	//x̏_ȉQ
    bool IsNeg;
    int len;
    AnsiString str;

    if(Temp<0){
    	IsNeg=true;
        Temp=-Temp;
    }else{
    	IsNeg=false;
    }
	HTemp=Temp/100;
    LTemp=Temp-(HTemp*100);
    if(IsNeg){
	    str.printf("-%d.%02d",HTemp,LTemp);
        len=50-HTemp;
    }else{
	    str.printf("%d.%02d",HTemp,LTemp);
		len=HTemp+50;
    }
    TempPnl->Caption=str;
    if(len>150)
    	len=150;
    else if(len<0)
    	len=0;
    TempShape->Top=TempShapeFrame->Top+(150-len);
    TempShape->Height=len;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StartBtnClick(TObject *Sender)
{
	//Start
	if(McpInit()){
    	StartBtn->Enabled=false;
    	StopBtn->Enabled=true;
        Timer1->Enabled=true;
    }else{
    	ShowMessage("Ɏs܂");
	    PortClose();
	}
}
//---------------------------------------------------------------------------
// I2C Interface
//---------------------------------------------------------------------------
void TForm1::InitTimeValue()
{
	unsigned int tic,tval;

    tval=0;
    tic=GetTickCount();
    while(tic==GetTickCount());

    tic=GetTickCount();
    while(tic==GetTickCount())
    	tval++;

    tval/=256;
    if(tval==0)
    	tval=1;
    TimeValue=tval;

}
//---------------------------------------------------------------------------
void TForm1::XDelay()
{
	int tic,tval;
    tval=TimeValue;
    while(tval){
    	GetTickCount();
        tval--;
    }
}
//---------------------------------------------------------------------------
void TForm1::StartCondition()
{
/*
	StartCondition:
    SCL	...|~~~~~~~~|______
    SDA ...|~~~~|__________
*/
	SCLCnt(1);
    SDACnt(1);
	XDelay();	//    Sleep(1);
    SDACnt(0);
    XDelay();	//Sleep(0);
    SCLCnt(0);
}

//---------------------------------------------------------------------------
void TForm1::StopCondition()
{
/*
	StopCondition:
    SCL	...____|~~~~~~~~
    SDA ...________|~~~~
*/
	SCLCnt(0);
    SDACnt(0);
    XDelay();	//Sleep(1);
    SCLCnt(1);
    XDelay();	//Sleep(1);
    SDACnt(1);
    XDelay();	//Sleep(1);
}
//---------------------------------------------------------------------------
bool TForm1::WriteByte(Byte dat)
{
	int cnt;
	bool nack;

   	SCLCnt(0);
    for(cnt=0;cnt<8;cnt++){
		XDelay();
        SDACnt(dat & 0x80);
        XDelay();
        SCLCnt(1);
        XDelay();
        XDelay();
        SCLCnt(0);
        dat <<=1;
    }
    //Check Ack//
   	SCLCnt(0);
    SDACnt(1);	// Tri-State
	XDelay();
	XDelay();
    SCLCnt(1);
    XDelay();
	nack=SDAChk();
    XDelay();
    SCLCnt(0);
    if(nack)
    	return false;
    return true;
}
//---------------------------------------------------------------------------
Byte TForm1::ReadByte(bool nack)
{
	int cnt;
    Byte dat=0;

   	SCLCnt(0);
    SDACnt(1);	// Tri-State
    for(cnt=0;cnt<8;cnt++){
        dat <<=1;
		XDelay();
		XDelay();
        SCLCnt(1);
        XDelay();
		if(SDAChk())
        	dat|=1;
        XDelay();
        SCLCnt(0);
    }
	// Send Ack //
   	SCLCnt(0);
	XDelay();
    SDACnt(nack);
    XDelay();
    SCLCnt(1);
    XDelay();
    XDelay();
    SCLCnt(0);
    return dat;
}

//---------------------------------------------------------------------------
bool TForm1::McpInit()
{
	//MCP3421̏
 	if(!PortOpen(cbPort->Text))
    	return false;
    StartCondition();
    WriteByte(0xd0);	//Write Command
    WriteByte(0x99);	//Continuous Mode,16bit,2V/V
    StopCondition();
}

//---------------------------------------------------------------------------
int TForm1::McpRead()
{
	//MCPfoCX1[h̃f[^ǂݏo
    short rdat;
    Byte cdat;
    Byte *pdat;
   	pdat=(Byte *)&rdat;
    StartCondition();
    WriteByte(0xd1);	//Read Command
    pdat[1]=ReadByte(false);
    pdat[0]=ReadByte(false);
    cdat=ReadByte(true);	//Configuration Byte
	StopCondition();
    return (int)rdat;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StopBtnClick(TObject *Sender)
{
	Timer1->Enabled=false;
    StopBtn->Enabled=false;
    StartBtn->Enabled=true;
    PortClose();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	PortClose();
}
//---------------------------------------------------------------------------
int TForm1::Convert(int dat)
{
	//x̓ǂݎf[^xf[^ɕϊ
    //xf[^́Ax~100̐l
    //LM35́A1A10mVAMCP3421́A1rbg31.25uV
    //]11/320BāAǂݎl3201xƂȂ
    //Ax100{ꂽlgp̂ŁAǂݎlx100/320
    //xƂȂ
    int rdat;
    rdat=(dat*100)/320;
    return rdat;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	//f[^̓ǂݏoƕ\
	int dat;
    dat=McpRead();
    ShowData(Convert(dat));
}
//---------------------------------------------------------------------------

